<?php
/**
 * Created by PhpStorm.
 * User: qf
 * Date: 2022-03-18
 * Time: 09:57
 */

if(!defined('IN_DISCUZ')) {
    exit('Access Denied');
}

function reply_discuzcode($message) {
    global $_G;
    $message = dhtmlspecialchars($message);
    if(strpos($message, '[/color]')){
        $message = str_replace(array('[/color]'), array('</font>'), preg_replace("/\[color=([#\w]+?)\]/i", "<font color=\"\\1\">", $message));
    }
    if(strpos($message, '[/b]')){
        $message = str_replace(array('[b]', '[/b]'), array('<b>', '</b>'), $message);
    }
    require_once libfile('function/discuzcode');
    $message = parsesmiles($message);
    return $message;
}


function qianfanCache($name, $value = '', $expire = 600)
{
    if (!$name || $name == 'config') {
        return '';
    }

    $timestamp = time();
    $cacheInfo = DB::fetch_first("SELECT * FROM %t WHERE name=%s", array('qianfan_plugin', $name));

    if ($value) {
        if ($cacheInfo) {
            DB::update("qianfan_plugin", array("value" => $value, "time" => $timestamp + $expire), array("name" => $name));
        } else {
            DB::insert("qianfan_plugin", array("name" => $name, "value" => $value, "time" => $timestamp + $expire));
        }
        return true;
    } else {
        if ($timestamp > $cacheInfo['time']) {
            return '';
        } else {
            return $cacheInfo['value'];
        }
    }
}


function ipLocate($ips)
{
    $resp = array();
    $configPath = rtrim(DISCUZ_ROOT, '/') . DIRECTORY_SEPARATOR . 'data' . DIRECTORY_SEPARATOR . 'sysdata' . DIRECTORY_SEPARATOR .
        'cache_qianfan_config.php';
    if (file_exists($configPath)) {
        require($configPath);
        if (isset($qianfan_config['cloud_host']) && isset($qianfan_config['cloud_secretkey'])) {
            $cloudhost = $qianfan_config['cloud_host'] ? $qianfan_config['cloud_host'] : '';
            $cloudsecretkey = $qianfan_config['cloud_secretkey'] ? $qianfan_config['cloud_secretkey'] : '';
            if ($cloudhost && $cloudsecretkey) {
                $apiUrl = rtrim($cloudhost, '/') . '/api1_2/thread/ip-locate';
                $postParams = array('ips' => $ips);
                $response = qfRequest($cloudsecretkey, $apiUrl, array(), $postParams);
                if ($response && json_decode($response, true) != null) {
                    $resp = json_decode($response, true);
                }
            }
        }
    }
    return $resp;
}

function qfRequest($secret_key, $url, $get_params, $post_data = array())
{
    $timeout = 5;
    $nonce = rand(10000, 99999);
    $timestamp = time();
    $array = array($nonce, $timestamp, $secret_key);
    sort($array, SORT_STRING);
    $token = md5(implode($array));
    $params['nonce'] = $nonce;
    $params['timestamp'] = $timestamp;
    $params['token'] = $token;
    $params = array_merge($params, $get_params);
    $url .= '?';
    foreach ($params as $k => $v) {
        $url .= $k . '=' . $v . '&';
    }
    $url = rtrim($url, '&');
    $curlHandle = curl_init();
    curl_setopt($curlHandle, CURLOPT_URL, $url);
    curl_setopt($curlHandle, CURLOPT_HEADER, 0);
    curl_setopt($curlHandle, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($curlHandle, CURLOPT_USERAGENT, 'bbs, qianfan');

    curl_setopt($curlHandle, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($curlHandle, CURLOPT_SSL_VERIFYHOST, FALSE);
    curl_setopt($curlHandle, CURLOPT_POST, count($post_data));
    curl_setopt($curlHandle, CURLOPT_POSTFIELDS, $post_data);
    curl_setopt($curlHandle, CURLOPT_CONNECTTIMEOUT, $timeout);
    curl_setopt($curlHandle, CURLOPT_TIMEOUT, $timeout);

    $data = curl_exec($curlHandle);
    $status = curl_getinfo($curlHandle, CURLINFO_HTTP_CODE);
    if ($status != 200) {
        return false;
    }
    curl_close($curlHandle);
    return $data;
}

?>